/**
 * Autogenerated by Thrift Compiler (0.13.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package org.eclipse.hawk.service.api;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked", "unused"})
@javax.annotation.Generated(value = "Autogenerated by Thrift Compiler (0.13.0)", date = "2021-04-18")
public class UnknownRepositoryType extends org.apache.thrift.TException implements org.apache.thrift.TBase<UnknownRepositoryType, UnknownRepositoryType._Fields>, java.io.Serializable, Cloneable, Comparable<UnknownRepositoryType> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("UnknownRepositoryType");

  private static final org.apache.thrift.protocol.TField REPOSITORY_TYPE_FIELD_DESC = new org.apache.thrift.protocol.TField("repositoryType", org.apache.thrift.protocol.TType.STRING, (short)1);

  private static final org.apache.thrift.scheme.SchemeFactory STANDARD_SCHEME_FACTORY = new UnknownRepositoryTypeStandardSchemeFactory();
  private static final org.apache.thrift.scheme.SchemeFactory TUPLE_SCHEME_FACTORY = new UnknownRepositoryTypeTupleSchemeFactory();

  public @org.apache.thrift.annotation.Nullable java.lang.String repositoryType; // optional

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    REPOSITORY_TYPE((short)1, "repositoryType");

    private static final java.util.Map<java.lang.String, _Fields> byName = new java.util.HashMap<java.lang.String, _Fields>();

    static {
      for (_Fields field : java.util.EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // REPOSITORY_TYPE
          return REPOSITORY_TYPE;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new java.lang.IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByName(java.lang.String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final java.lang.String _fieldName;

    _Fields(short thriftId, java.lang.String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public java.lang.String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final _Fields optionals[] = {_Fields.REPOSITORY_TYPE};
  public static final java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new java.util.EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.REPOSITORY_TYPE, new org.apache.thrift.meta_data.FieldMetaData("repositoryType", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    metaDataMap = java.util.Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(UnknownRepositoryType.class, metaDataMap);
  }

  public UnknownRepositoryType() {
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public UnknownRepositoryType(UnknownRepositoryType other) {
    if (other.isSetRepositoryType()) {
      this.repositoryType = other.repositoryType;
    }
  }

  public UnknownRepositoryType deepCopy() {
    return new UnknownRepositoryType(this);
  }

  @Override
  public void clear() {
    this.repositoryType = null;
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getRepositoryType() {
    return this.repositoryType;
  }

  public UnknownRepositoryType setRepositoryType(@org.apache.thrift.annotation.Nullable java.lang.String repositoryType) {
    this.repositoryType = repositoryType;
    return this;
  }

  public void unsetRepositoryType() {
    this.repositoryType = null;
  }

  /** Returns true if field repositoryType is set (has been assigned a value) and false otherwise */
  public boolean isSetRepositoryType() {
    return this.repositoryType != null;
  }

  public void setRepositoryTypeIsSet(boolean value) {
    if (!value) {
      this.repositoryType = null;
    }
  }

  public void setFieldValue(_Fields field, @org.apache.thrift.annotation.Nullable java.lang.Object value) {
    switch (field) {
    case REPOSITORY_TYPE:
      if (value == null) {
        unsetRepositoryType();
      } else {
        setRepositoryType((java.lang.String)value);
      }
      break;

    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.Object getFieldValue(_Fields field) {
    switch (field) {
    case REPOSITORY_TYPE:
      return getRepositoryType();

    }
    throw new java.lang.IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new java.lang.IllegalArgumentException();
    }

    switch (field) {
    case REPOSITORY_TYPE:
      return isSetRepositoryType();
    }
    throw new java.lang.IllegalStateException();
  }

  @Override
  public boolean equals(java.lang.Object that) {
    if (that == null)
      return false;
    if (that instanceof UnknownRepositoryType)
      return this.equals((UnknownRepositoryType)that);
    return false;
  }

  public boolean equals(UnknownRepositoryType that) {
    if (that == null)
      return false;
    if (this == that)
      return true;

    boolean this_present_repositoryType = true && this.isSetRepositoryType();
    boolean that_present_repositoryType = true && that.isSetRepositoryType();
    if (this_present_repositoryType || that_present_repositoryType) {
      if (!(this_present_repositoryType && that_present_repositoryType))
        return false;
      if (!this.repositoryType.equals(that.repositoryType))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    int hashCode = 1;

    hashCode = hashCode * 8191 + ((isSetRepositoryType()) ? 131071 : 524287);
    if (isSetRepositoryType())
      hashCode = hashCode * 8191 + repositoryType.hashCode();

    return hashCode;
  }

  @Override
  public int compareTo(UnknownRepositoryType other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = java.lang.Boolean.valueOf(isSetRepositoryType()).compareTo(other.isSetRepositoryType());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetRepositoryType()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.repositoryType, other.repositoryType);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  @org.apache.thrift.annotation.Nullable
  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    scheme(iprot).read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    scheme(oprot).write(oprot, this);
  }

  @Override
  public java.lang.String toString() {
    java.lang.StringBuilder sb = new java.lang.StringBuilder("UnknownRepositoryType(");
    boolean first = true;

    if (isSetRepositoryType()) {
      sb.append("repositoryType:");
      if (this.repositoryType == null) {
        sb.append("null");
      } else {
        sb.append(this.repositoryType);
      }
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, java.lang.ClassNotFoundException {
    try {
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class UnknownRepositoryTypeStandardSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public UnknownRepositoryTypeStandardScheme getScheme() {
      return new UnknownRepositoryTypeStandardScheme();
    }
  }

  private static class UnknownRepositoryTypeStandardScheme extends org.apache.thrift.scheme.StandardScheme<UnknownRepositoryType> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, UnknownRepositoryType struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // REPOSITORY_TYPE
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.repositoryType = iprot.readString();
              struct.setRepositoryTypeIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, UnknownRepositoryType struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (struct.repositoryType != null) {
        if (struct.isSetRepositoryType()) {
          oprot.writeFieldBegin(REPOSITORY_TYPE_FIELD_DESC);
          oprot.writeString(struct.repositoryType);
          oprot.writeFieldEnd();
        }
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class UnknownRepositoryTypeTupleSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public UnknownRepositoryTypeTupleScheme getScheme() {
      return new UnknownRepositoryTypeTupleScheme();
    }
  }

  private static class UnknownRepositoryTypeTupleScheme extends org.apache.thrift.scheme.TupleScheme<UnknownRepositoryType> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, UnknownRepositoryType struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol oprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      java.util.BitSet optionals = new java.util.BitSet();
      if (struct.isSetRepositoryType()) {
        optionals.set(0);
      }
      oprot.writeBitSet(optionals, 1);
      if (struct.isSetRepositoryType()) {
        oprot.writeString(struct.repositoryType);
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, UnknownRepositoryType struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol iprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      java.util.BitSet incoming = iprot.readBitSet(1);
      if (incoming.get(0)) {
        struct.repositoryType = iprot.readString();
        struct.setRepositoryTypeIsSet(true);
      }
    }
  }

  private static <S extends org.apache.thrift.scheme.IScheme> S scheme(org.apache.thrift.protocol.TProtocol proto) {
    return (org.apache.thrift.scheme.StandardScheme.class.equals(proto.getScheme()) ? STANDARD_SCHEME_FACTORY : TUPLE_SCHEME_FACTORY).getScheme();
  }
}

